clang 10.0.0git

Public Types | Public Member Functions | List of all members
clang::PluginASTAction Class Referenceabstract

`#include "clang/Frontend/FrontendAction.h"`

Inheritance diagram for clang::PluginASTAction:
[legend]
Collaboration diagram for clang::PluginASTAction:
[legend]

## Public Types
enum | ActionType { Cmdline, ReplaceAction, AddBeforeMainAction, AddAfterMainAction }

## Public Member Functions
std::unique_ptr< ASTConsumer > | CreateASTConsumer (CompilerInstance &CI, StringRef InFile) override=0
| Create the AST consumer object for this action, if supported. More...
virtual bool | ParseArgs (const CompilerInstance &CI, const std::vector< std::string > &arg)=0
| Parse the given plugin command line arguments. More...
virtual ActionType | getActionType ()
| Get the action type for this plugin. More...
Public Member Functions inherited from clang::ASTFrontendAction
| ASTFrontendAction ()
bool | usesPreprocessorOnly () const override
| Does this action only use the preprocessor? More...
Public Member Functions inherited from clang::FrontendAction
| FrontendAction ()
virtual | ~FrontendAction ()
CompilerInstance & | getCompilerInstance () const
void | setCompilerInstance (CompilerInstance *Value)
bool | isCurrentFileAST () const
const FrontendInputFile & | getCurrentInput () const
StringRef | getCurrentFile () const
StringRef | getCurrentFileOrBufferName () const
InputKind | getCurrentFileKind () const
ASTUnit & | getCurrentASTUnit () const
Module * | getCurrentModule () const
std::unique_ptr< ASTUnit > | takeCurrentASTUnit ()
void | setCurrentInput (const FrontendInputFile &CurrentInput, std::unique_ptr< ASTUnit > AST=nullptr)
virtual bool | isModelParsingAction () const
| Is this action invoked on a model file? More...
virtual TranslationUnitKind | getTranslationUnitKind ()
| For AST-based actions, the kind of translation unit we're handling. More...
virtual bool | hasPCHSupport () const
| Does this action support use with PCH? More...
virtual bool | hasASTFileSupport () const
| Does this action support use with AST files? More...
virtual bool | hasIRSupport () const
| Does this action support use with IR files? More...
virtual bool | hasCodeCompletionSupport () const
| Does this action support use with code completion? More...
bool | PrepareToExecute (CompilerInstance &CI)
| Prepare the action to execute on the given compiler instance. More...
bool | BeginSourceFile (CompilerInstance &CI, const FrontendInputFile &Input)
| Prepare the action for processing the input file `Input`. More...
llvm::Error | Execute ()
| Set the source manager's main input file, and run the action. More...
void | EndSourceFile ()
| Perform any per-file post processing, deallocate per-file objects, and run statistics and output file cleanup code. More...

## Additional Inherited Members
Protected Member Functions inherited from clang::ASTFrontendAction
void | ExecuteAction () override
| Implement the ExecuteAction interface by running Sema on the already-initialized AST consumer. More...
Protected Member Functions inherited from clang::FrontendAction
virtual bool | PrepareToExecuteAction (CompilerInstance &CI)
| Prepare to execute the action on the given CompilerInstance. More...
virtual bool | BeginInvocation (CompilerInstance &CI)
| Callback before starting processing a single input, giving the opportunity to modify the CompilerInvocation or do some other action before BeginSourceFileAction is called. More...
virtual bool | BeginSourceFileAction (CompilerInstance &CI)
| Callback at the start of processing a single input. More...
virtual void | EndSourceFileAction ()
| Callback at the end of processing a single input. More...
virtual bool | shouldEraseOutputFiles ()
| Callback at the end of processing a single input, to determine if the output files should be erased or not. More...

## Detailed Description

Definition at line 257 of file FrontendAction.h.

## Member Enumeration Documentation

## ◆ ActionType

enum clang::PluginASTAction::ActionType

Enumerator
Cmdline | Action is determined by the cc1 command-line.
ReplaceAction | Replace the main action.
AddBeforeMainAction | Execute the action before the main action.
AddAfterMainAction | Execute the action after the main action.

Definition at line 272 of file FrontendAction.h.

## Member Function Documentation

## ◆ CreateASTConsumer()

std::unique_ptr<ASTConsumer> clang::PluginASTAction::CreateASTConsumer | ( | CompilerInstance & | CI,
|  | StringRef | InFile
| ) |  |
| override pure virtual

Create the AST consumer object for this action, if supported.

This routine is called as part of BeginSourceFile(), which will fail if the AST consumer cannot be created. This will not be called if the action has indicated that it only uses the preprocessor.

Parameters

  CI | - The current compiler instance, provided as a convenience, see getCompilerInstance().
  InFile | - The current input file, provided as a convenience, see getCurrentFile().

Returns
  The new AST consumer, or null on failure.

Implements clang::FrontendAction.

## ◆ getActionType()

virtual ActionType clang::PluginASTAction::getActionType | ( |  | ) |
| inline virtual

Get the action type for this plugin.

Returns
  The action type. If the type is Cmdline then by default the plugin does nothing and what it does is determined by the cc1 command-line.

Definition at line 283 of file FrontendAction.h.

## ◆ ParseArgs()

virtual bool clang::PluginASTAction::ParseArgs | ( | const CompilerInstance & | CI,
|  | const std::vector< std::string > & | arg
| ) |  |
| pure virtual

Parse the given plugin command line arguments.

Parameters

  CI | - The compiler instance, for use in reporting diagnostics.

Returns
  True if the parsing succeeded; otherwise the plugin will be destroyed and no action run. The plugin is responsible for using the CompilerInstance's Diagnostic object to report errors.

The documentation for this class was generated from the following files:

- include/clang/Frontend/FrontendAction.h
- lib/Frontend/FrontendAction.cpp